// sample8_1_1.cpp : C vWFNg t@CłB

#include "stdafx.h"
#include <iostream>
#include <iomanip>

using namespace System;
using namespace std;

	//
	//		KEXEWh̐ϕɂKI@
	//
	class AdaptiveGL {
		public:
			double (*f)(double);
			AdaptiveGL(){}
			virtual ~AdaptiveGL(){}

			double integral( double a, double b, double (*func)(double));
			void   calcIntegral( double & s0, double a, double b );
			double Gauss_Legendre( double a, double b );
	};
	//
	//		֐funcab܂ł̐ϕ߂B
	//
	double AdaptiveGL::integral(double a, double b, double (*func)(double)){
		f = func;
		double v = 0.0;
		calcIntegral( v, a, b );
		return v;
	}
	//
	//		KI@̂߂̍ċAĂяo
	//
	void AdaptiveGL::calcIntegral(double & s0, double a, double b){
		double s1 = Gauss_Legendre( a, 0.5*(a + b) );
		double s2 = Gauss_Legendre( 0.5*(a + b), b );
		if (((Math::Abs( s0 - s1 - s2 ) < (1.0e-14)*Math::Abs(s1 + s2))
			|| 
			((Math::Abs(s0) + Math::Abs(s1 + s2)) < 1.0e-14))
			&&
			(Math::Abs(b - a) < 1.0)){
				s0 = s1 + s2;
				return;
		}
		else{
				calcIntegral( s1, a, 0.5*(a + b) );
				calcIntegral( s2, 0.5*(a + b), b );
				s0 = s1 + s2;
				return;
		}
	}
	//
	//		KEXEWh̐ϕ
	//
	double AdaptiveGL::Gauss_Legendre(double a, double b){
		double x0[9] = {
		    			   -9.68160239507626090E-0001,
						   -8.36031107326635794E-0001,
						   -6.13371432700590397E-0001,
						   -3.24253423403808929E-0001,
							0.00000000000000000E+0000,
							3.24253423403808929E-0001,
							6.13371432700590397E-0001,
							8.36031107326635794E-0001,
							9.68160239507626090E-0001
		};
		double w[9] = {
							8.12743883615744120E-0002,
							1.80648160694857404E-0001,
							2.60610696402935462E-0001,
							3.12347077040002840E-0001,
							3.30239355001259763E-0001,
							3.12347077040002840E-0001,
							2.60610696402935462E-0001,
							1.80648160694857404E-0001,
							8.12743883615744120E-0002  
		};
		double v1 = 0.0;
		double i_w = b - a;
		double xi;
		for (int i = 0; i < 9; i++){
			xi = (0.5 * i_w * x0[i]) + (0.5 * (b + a));
			v1 += w[i] * f(xi);
		}
		v1 = 0.5 * i_w * v1;
		return v1;
	}
	//
	//		WKz̊mx֐萔W
	//
	double normalDistriK( double z ){
		return Math::Exp(-0.5 * z * z);
	}
	//
	//		WKݐϊm֐: 
	//
	double CumNormal( double z ){
		AdaptiveGL agl;
		double v = 0.5;
		if (z > 0.0){
			v = 0.5 + agl.integral( 0.0, z, normalDistriK ) / Math::Sqrt(2 * Math::PI);
		}else if (z < 0.0){
			v = 0.5 - agl.integral(z, 0.0, normalDistriK) / Math::Sqrt(2 * Math::PI);
		}
		return v;
	}

int main(array<System::String ^> ^args)
{
	cout << "z = ";
	double z;
	cin >> z;
	//
	//		p = Prob( X <= z );  X ` WKz
	//
	double p = CumNormal( z );
	cout << "p = " << setprecision(12) << p << endl;

	Console::WriteLine();
    Console::WriteLine("EnterL[ďIB");
	Console::ReadLine();
    return 0;
}
